-- BarcodeTalk.applescript
-- BarcodeTalk

--  Created by Greg Kearney on 2/23/09.
--  Copyright 2009 __MyCompanyName__. All rights reserved.

on end editing theObject
	set mypath to ((path to me) as Unicode text)
	set theDocs to path to "docs" as string
	set dbpath to quoted form of (POSIX path of (theDocs & "items.csv"))
	set userfilepath to quoted form of (POSIX path of (theDocs & "useritems.csv"))
	--set userfilepath2 to (POSIX path of (theDocs & "useritems.csv"))
	
	set mycode to the contents of text field "barcode" of window "main"
	set msg to "no"
	set len2 to 0
	try
		do shell script "/bin/ls " & userfilepath
		set msg to "yes"
	on error errMsg number errNum
		set msg to "no"
	end try
	if msg is "yes" then
		set cmd to "/usr/bin/grep " & mycode & " " & userfilepath & " |awk -F , '{print tolower($2)}';"
		log cmd
		
		set shellresult to do shell script cmd
		set len1 to (length of mycode) + 0
		set len2 to length of shellresult
		if len2 > 0 then
			set saypart to items len1 through len2 of shellresult as string
		end if
	end if
	
	if len2 = 0 then
		
		try
			do shell script "/bin/ls " & dbpath
			set msg to "yes"
		on error errMsg number errNum
			set msg to "no"
		end try
		
		
		if msg is "yes" then
			set cmd to "/usr/bin/grep " & mycode & " " & dbpath & " |awk -F , '{print tolower($2)  \", \" tolower($3)}';"
			set shellresult to do shell script cmd
			set len1 to (length of mycode) + 0
			set len2 to length of shellresult
			if len2 > 0 then
				set saypart to items len1 through len2 of shellresult as string
			end if
		end if
	end if
	
	if len2 > 0 then
		say saypart
	else
		say "barcode not found."
	end if
end end editing


--the older code
(*
on end editing theObject
	set mypath to ((path to me) as Unicode text)
	set plscriptpath to quoted form of (POSIX path of (mypath & "Contents:Resources:barcode.pl"))
	set theDocs to path to "docs" as string
	set dbpath to quoted form of (POSIX path of (theDocs & "items.csv"))
	set userfilepath to quoted form of (POSIX path of (theDocs & "useritems.csv"))
	set mycode to the contents of text field "barcode" of window "main"
	set cmd to "/usr/bin/perl " & plscriptpath & " " & mycode & " " & dbpath & " " & userfilepath
	--log cmd
	
	set shellresult to do shell script cmd
end end editing

*)

on clicked theObject
	if the name of theObject is "save_btn" then
		set mypath to ((path to me) as Unicode text)
		set plscriptpath to quoted form of (POSIX path of (mypath & "Contents:Resources:additem.pl"))
		set theDocs to path to "docs" as string
		set dbpath to quoted form of (POSIX path of (theDocs & "useritems.csv"))
		set userbarcode to the contents of text field "itemdarcode" of window "additem"
		set userdesc to the contents of text field "itemdesc" of window "additem"
		set additemtext to userbarcode & "," & userdesc
		set cmd to "/usr/bin/perl " & plscriptpath & " '" & userbarcode & "'  '" & userdesc & "' " & dbpath
		--log cmd
		set shellresult to do shell script cmd
		set visible of window "additem" to false
	end if
end clicked

on choose menu item theObject
	if the name of theObject is "add_item_menu" then
		set visible of window "additem" to true
	end if
end choose menu item


(*
on awake from nib theObject
	if the name of theObject is "appmenu" then
		set theDocs to path to "docs" as string
		set dbpath to quoted form of (POSIX path of (theDocs & "items.enc"))
		set openssl to "openssl enc -d -aes-256-cbc -in " & dbpath & " -out /tmp/items.csv -pass pass:ogc1976"
		log openssl
		set shellresult to do shell script openssl
	end if
end awake from nib

on will quit theObject
	set theDocs to path to "docs" as string
	set dbpath to (POSIX path of ("/tmp/itmes.csv"))
	set rm to "rm -f " & dbpath
	log rm
	set shellresult to do shell script rm
end will quit

*)










